
_interrupt:

;ballisticchronograph.mbas,152 :: 		sub procedure interrupt
;ballisticchronograph.mbas,154 :: 		if INT2IF_bit then    '---- 2nd screen
	BTFSS       INT2IF_bit+0, BitPos(INT2IF_bit+0) 
	GOTO        L__interrupt2
;ballisticchronograph.mbas,155 :: 		tmr1L_save = TMR1L
	MOVF        TMR1L+0, 0 
	MOVWF       _tmr1L_save+0 
;ballisticchronograph.mbas,156 :: 		tmr1H_save = TMR1H
	MOVF        TMR1H+0, 0 
	MOVWF       _tmr1H_save+0 
;ballisticchronograph.mbas,157 :: 		INT2IE_bit = INTERRUPT_DISABLE
	BCF         INT2IE_bit+0, BitPos(INT2IE_bit+0) 
;ballisticchronograph.mbas,158 :: 		if (tmr1H_save = 0) and (TMR1IF_bit = FLAG_SET) then
	MOVF        _tmr1H_save+0, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R1 
	BTFSC       TMR1IF_bit+0, BitPos(TMR1IF_bit+0) 
	GOTO        L__interrupt297
	BCF         4056, 0 
	GOTO        L__interrupt298
L__interrupt297:
	BSF         4056, 0 
L__interrupt298:
	CLRF        R0 
	BTFSC       4056, 0 
	INCF        R0, 1 
	MOVF        R1, 0 
	ANDWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__interrupt5
;ballisticchronograph.mbas,159 :: 		tmr1_oveflow_count_save = tmr1_oveflow_count + 1
	MOVF        _tmr1_oveflow_count+0, 0 
	ADDLW       1
	MOVWF       _tmr1_oveflow_count_save+0 
	GOTO        L__interrupt6
;ballisticchronograph.mbas,160 :: 		else
L__interrupt5:
;ballisticchronograph.mbas,161 :: 		tmr1_oveflow_count_save = tmr1_oveflow_count
	MOVF        _tmr1_oveflow_count+0, 0 
	MOVWF       _tmr1_oveflow_count_save+0 
;ballisticchronograph.mbas,162 :: 		end if
L__interrupt6:
;ballisticchronograph.mbas,163 :: 		TMR1ON_bit = TIMER_OFF
	BCF         TMR1ON_bit+0, BitPos(TMR1ON_bit+0) 
;ballisticchronograph.mbas,164 :: 		TMR1IF_bit = FLAG_CLEAR
	BCF         TMR1IF_bit+0, BitPos(TMR1IF_bit+0) 
;ballisticchronograph.mbas,165 :: 		TMR1IE_bit = INTERRUPT_DISABLE
	BCF         TMR1IE_bit+0, BitPos(TMR1IE_bit+0) 
;ballisticchronograph.mbas,166 :: 		screen2nd_detect = True
	MOVLW       255
	MOVWF       _screen2nd_detect+0 
;ballisticchronograph.mbas,167 :: 		INT2IF_bit = FLAG_CLEAR
	BCF         INT2IF_bit+0, BitPos(INT2IF_bit+0) 
	GOTO        L__interrupt3
;ballisticchronograph.mbas,168 :: 		else  '---- 1st screen
L__interrupt2:
;ballisticchronograph.mbas,169 :: 		TMR1H = 0
	CLRF        TMR1H+0 
;ballisticchronograph.mbas,170 :: 		TMR1L = 0
	CLRF        TMR1L+0 
;ballisticchronograph.mbas,171 :: 		INT0IE_bit   = INTERRUPT_DISABLE
	BCF         INT0IE_bit+0, BitPos(INT0IE_bit+0) 
;ballisticchronograph.mbas,172 :: 		tmr1_oveflow_count = 0
	CLRF        _tmr1_oveflow_count+0 
;ballisticchronograph.mbas,173 :: 		TMR1IF_bit  = FLAG_CLEAR
	BCF         TMR1IF_bit+0, BitPos(TMR1IF_bit+0) 
;ballisticchronograph.mbas,174 :: 		TMR1IE_bit  = TIMER_ON
	BSF         TMR1IE_bit+0, BitPos(TMR1IE_bit+0) 
;ballisticchronograph.mbas,175 :: 		TMR1ON_bit  = ENABLE
	BSF         TMR1ON_bit+0, BitPos(TMR1ON_bit+0) 
;ballisticchronograph.mbas,176 :: 		INT2IF_bit  = FLAG_CLEAR
	BCF         INT2IF_bit+0, BitPos(INT2IF_bit+0) 
;ballisticchronograph.mbas,177 :: 		INT2IE_bit  = INTERRUPT_ENABLE
	BSF         INT2IE_bit+0, BitPos(INT2IE_bit+0) 
;ballisticchronograph.mbas,178 :: 		screen1st_detect = True
	MOVLW       255
	MOVWF       _screen1st_detect+0 
;ballisticchronograph.mbas,179 :: 		screen_timeout = False
	CLRF        _screen_timeout+0 
;ballisticchronograph.mbas,180 :: 		INT0IF_bit  = FLAG_CLEAR
	BCF         INT0IF_bit+0, BitPos(INT0IF_bit+0) 
;ballisticchronograph.mbas,181 :: 		end if
L__interrupt3:
;ballisticchronograph.mbas,182 :: 		end sub
L_end_interrupt:
L__interrupt296:
	RETFIE      1
; end of _interrupt

_interrupt_low:
	MOVWF       ___Low_saveWREG+0 
	MOVF        STATUS+0, 0 
	MOVWF       ___Low_saveSTATUS+0 
	MOVF        BSR+0, 0 
	MOVWF       ___Low_saveBSR+0 

;ballisticchronograph.mbas,185 :: 		sub procedure interrupt_low
;ballisticchronograph.mbas,187 :: 		if TMR1IF_bit then
	BTFSS       TMR1IF_bit+0, BitPos(TMR1IF_bit+0) 
	GOTO        L__interrupt_low9
;ballisticchronograph.mbas,188 :: 		if tmr1_oveflow_count < SCREEN2_TIMEOUT_COUNT then
	MOVLW       100
	SUBWF       _tmr1_oveflow_count+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__interrupt_low12
;ballisticchronograph.mbas,189 :: 		tmr1_oveflow_count = tmr1_oveflow_count + 1
	INCF        _tmr1_oveflow_count+0, 1 
	GOTO        L__interrupt_low13
;ballisticchronograph.mbas,190 :: 		else
L__interrupt_low12:
;ballisticchronograph.mbas,191 :: 		screen_timeout = True
	MOVLW       255
	MOVWF       _screen_timeout+0 
;ballisticchronograph.mbas,192 :: 		end if
L__interrupt_low13:
;ballisticchronograph.mbas,193 :: 		TMR1IF_bit = FLAG_CLEAR
	BCF         TMR1IF_bit+0, BitPos(TMR1IF_bit+0) 
L__interrupt_low9:
;ballisticchronograph.mbas,197 :: 		if TMR0IF_bit then
	BTFSS       TMR0IF_bit+0, BitPos(TMR0IF_bit+0) 
	GOTO        L__interrupt_low15
;ballisticchronograph.mbas,198 :: 		TMR0L = 6
	MOVLW       6
	MOVWF       TMR0L+0 
;ballisticchronograph.mbas,200 :: 		case 1
	MOVF        _led_pos+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt_low20
;ballisticchronograph.mbas,201 :: 		LED_DEV4_bit = LED_OFF
	BCF         LATA+0, 1 
;ballisticchronograph.mbas,202 :: 		LED_SEG_PORT = led_val4
	MOVF        _led_val4+0, 0 
	MOVWF       LATC+0 
;ballisticchronograph.mbas,203 :: 		LED_DEV1_bit = LED_ON
	BSF         LATB+0, 6 
;ballisticchronograph.mbas,204 :: 		led_pos = led_pos + 1
	INCF        _led_pos+0, 1 
	GOTO        L__interrupt_low17
L__interrupt_low20:
;ballisticchronograph.mbas,205 :: 		case 2
	MOVF        _led_pos+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt_low23
;ballisticchronograph.mbas,206 :: 		LED_DEV1_bit = LED_OFF
	BCF         LATB+0, 6 
;ballisticchronograph.mbas,207 :: 		LED_SEG_PORT = led_val3
	MOVF        _led_val3+0, 0 
	MOVWF       LATC+0 
;ballisticchronograph.mbas,208 :: 		LED_DEV2_bit = LED_ON
	BSF         LATB+0, 5 
;ballisticchronograph.mbas,209 :: 		led_pos = led_pos + 1
	INCF        _led_pos+0, 1 
	GOTO        L__interrupt_low17
L__interrupt_low23:
;ballisticchronograph.mbas,210 :: 		case 3
	MOVF        _led_pos+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt_low26
;ballisticchronograph.mbas,211 :: 		LED_DEV2_bit = LED_OFF
	BCF         LATB+0, 5 
;ballisticchronograph.mbas,212 :: 		LED_SEG_PORT = led_val2
	MOVF        _led_val2+0, 0 
	MOVWF       LATC+0 
;ballisticchronograph.mbas,213 :: 		LED_DEV3_bit = LED_ON
	BSF         LATB+0, 4 
;ballisticchronograph.mbas,214 :: 		led_pos = led_pos + 1
	INCF        _led_pos+0, 1 
	GOTO        L__interrupt_low17
L__interrupt_low26:
;ballisticchronograph.mbas,215 :: 		case 4
	MOVF        _led_pos+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt_low29
;ballisticchronograph.mbas,216 :: 		LED_DEV3_bit = LED_OFF
	BCF         LATB+0, 4 
;ballisticchronograph.mbas,217 :: 		LED_SEG_PORT = led_val1
	MOVF        _led_val1+0, 0 
	MOVWF       LATC+0 
;ballisticchronograph.mbas,218 :: 		LED_DEV4_bit = LED_ON
	BSF         LATA+0, 1 
;ballisticchronograph.mbas,219 :: 		led_pos = 1
	MOVLW       1
	MOVWF       _led_pos+0 
	GOTO        L__interrupt_low17
L__interrupt_low29:
L__interrupt_low17:
;ballisticchronograph.mbas,222 :: 		if sw_enable = false then
	MOVF        _sw_enable+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt_low31
;ballisticchronograph.mbas,223 :: 		if (SW1_bit + SW2_bit) = 2 then  ' switch released
	CLRF        R1 
	BTFSC       PORTA+0, 3 
	INCF        R1, 1 
	CLRF        R0 
	BTFSC       PORTB+0, 7 
	INCF        R0, 1 
	MOVF        R0, 0 
	ADDWF       R1, 1 
	MOVF        R1, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt_low34
;ballisticchronograph.mbas,224 :: 		if 0 < sw_off_counter then
	MOVLW       0
	MOVWF       R0 
	MOVF        _sw_off_counter+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt_low301
	MOVF        _sw_off_counter+0, 0 
	SUBLW       0
L__interrupt_low301:
	BTFSC       STATUS+0, 0 
	GOTO        L__interrupt_low37
;ballisticchronograph.mbas,225 :: 		sw_off_counter = sw_off_counter - 1
	MOVLW       1
	SUBWF       _sw_off_counter+0, 1 
	MOVLW       0
	SUBWFB      _sw_off_counter+1, 1 
L__interrupt_low37:
;ballisticchronograph.mbas,226 :: 		end if
	GOTO        L__interrupt_low35
;ballisticchronograph.mbas,227 :: 		else                             ' switch pressed
L__interrupt_low34:
;ballisticchronograph.mbas,228 :: 		sw_off_counter = SW_BOUNCE_TIME
	MOVLW       30
	MOVWF       _sw_off_counter+0 
	MOVLW       0
	MOVWF       _sw_off_counter+1 
;ballisticchronograph.mbas,229 :: 		sw_enable = false
	CLRF        _sw_enable+0 
;ballisticchronograph.mbas,230 :: 		end if
L__interrupt_low35:
L__interrupt_low31:
;ballisticchronograph.mbas,232 :: 		if sw_off_counter = 0 then
	MOVLW       0
	XORWF       _sw_off_counter+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt_low302
	MOVLW       0
	XORWF       _sw_off_counter+0, 0 
L__interrupt_low302:
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt_low40
;ballisticchronograph.mbas,233 :: 		sw_enable = true
	MOVLW       255
	MOVWF       _sw_enable+0 
L__interrupt_low40:
;ballisticchronograph.mbas,236 :: 		if SW1_bit = SW_ON then
	BTFSC       PORTA+0, 3 
	GOTO        L__interrupt_low43
;ballisticchronograph.mbas,237 :: 		if sw1_long_counter < MAX_SWITCH_TIME then
	MOVLW       39
	SUBWF       _sw1_long_counter+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt_low303
	MOVLW       16
	SUBWF       _sw1_long_counter+0, 0 
L__interrupt_low303:
	BTFSC       STATUS+0, 0 
	GOTO        L__interrupt_low46
;ballisticchronograph.mbas,238 :: 		sw1_long_counter = sw1_long_counter + 1
	INFSNZ      _sw1_long_counter+0, 1 
	INCF        _sw1_long_counter+1, 1 
L__interrupt_low46:
;ballisticchronograph.mbas,239 :: 		end if
	GOTO        L__interrupt_low44
;ballisticchronograph.mbas,240 :: 		else
L__interrupt_low43:
;ballisticchronograph.mbas,241 :: 		sw1_long_counter = 0
	CLRF        _sw1_long_counter+0 
	CLRF        _sw1_long_counter+1 
;ballisticchronograph.mbas,242 :: 		end if
L__interrupt_low44:
;ballisticchronograph.mbas,244 :: 		if SW2_bit = SW_ON then
	BTFSC       PORTB+0, 7 
	GOTO        L__interrupt_low49
;ballisticchronograph.mbas,245 :: 		if sw2_long_counter < MAX_SWITCH_TIME then
	MOVLW       39
	SUBWF       _sw2_long_counter+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt_low304
	MOVLW       16
	SUBWF       _sw2_long_counter+0, 0 
L__interrupt_low304:
	BTFSC       STATUS+0, 0 
	GOTO        L__interrupt_low52
;ballisticchronograph.mbas,246 :: 		sw2_long_counter = sw2_long_counter + 1
	INFSNZ      _sw2_long_counter+0, 1 
	INCF        _sw2_long_counter+1, 1 
L__interrupt_low52:
;ballisticchronograph.mbas,247 :: 		end if
	GOTO        L__interrupt_low50
;ballisticchronograph.mbas,248 :: 		else
L__interrupt_low49:
;ballisticchronograph.mbas,249 :: 		sw2_long_counter = 0
	CLRF        _sw2_long_counter+0 
	CLRF        _sw2_long_counter+1 
;ballisticchronograph.mbas,250 :: 		end if
L__interrupt_low50:
L__interrupt_low15:
;ballisticchronograph.mbas,253 :: 		TMR0IF_bit = FLAG_CLEAR
	BCF         TMR0IF_bit+0, BitPos(TMR0IF_bit+0) 
;ballisticchronograph.mbas,254 :: 		end sub
L_end_interrupt_low:
L__interrupt_low300:
	MOVF        ___Low_saveBSR+0, 0 
	MOVWF       BSR+0 
	MOVF        ___Low_saveSTATUS+0, 0 
	MOVWF       STATUS+0 
	SWAPF       ___Low_saveWREG+0, 1 
	SWAPF       ___Low_saveWREG+0, 0 
	RETFIE      0
; end of _interrupt_low

_led7seg_decode:

;ballisticchronograph.mbas,259 :: 		sub function led7seg_decode( dim ascii_char as byte ) as byte
;ballisticchronograph.mbas,260 :: 		if upside_down then
	MOVF        _upside_down+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__led7seg_decode56
;ballisticchronograph.mbas,262 :: 		case " "  result = Digit_NON
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       32
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode61
	CLRF        R1 
	GOTO        L__led7seg_decode58
L__led7seg_decode61:
;ballisticchronograph.mbas,263 :: 		case "0"  result = Digit_usd_0
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       48
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode64
	MOVLW       252
	MOVWF       R1 
	GOTO        L__led7seg_decode58
L__led7seg_decode64:
;ballisticchronograph.mbas,264 :: 		case "1"  result = Digit_usd_1
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       49
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode67
	MOVLW       12
	MOVWF       R1 
	GOTO        L__led7seg_decode58
L__led7seg_decode67:
;ballisticchronograph.mbas,265 :: 		case "2"  result = Digit_usd_2
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       50
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode70
	MOVLW       218
	MOVWF       R1 
	GOTO        L__led7seg_decode58
L__led7seg_decode70:
;ballisticchronograph.mbas,266 :: 		case "3"  result = Digit_usd_3
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       51
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode73
	MOVLW       158
	MOVWF       R1 
	GOTO        L__led7seg_decode58
L__led7seg_decode73:
;ballisticchronograph.mbas,267 :: 		case "4"  result = Digit_usd_4
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       52
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode76
	MOVLW       46
	MOVWF       R1 
	GOTO        L__led7seg_decode58
L__led7seg_decode76:
;ballisticchronograph.mbas,268 :: 		case "5"  result = Digit_usd_5
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       53
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode79
	MOVLW       182
	MOVWF       R1 
	GOTO        L__led7seg_decode58
L__led7seg_decode79:
;ballisticchronograph.mbas,269 :: 		case "6"  result = Digit_usd_6
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       54
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode82
	MOVLW       246
	MOVWF       R1 
	GOTO        L__led7seg_decode58
L__led7seg_decode82:
;ballisticchronograph.mbas,270 :: 		case "7"  result = Digit_usd_7
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       55
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode85
	MOVLW       28
	MOVWF       R1 
	GOTO        L__led7seg_decode58
L__led7seg_decode85:
;ballisticchronograph.mbas,271 :: 		case "8"  result = Digit_usd_8
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       56
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode88
	MOVLW       254
	MOVWF       R1 
	GOTO        L__led7seg_decode58
L__led7seg_decode88:
;ballisticchronograph.mbas,272 :: 		case "9"  result = Digit_usd_9
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       57
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode91
	MOVLW       190
	MOVWF       R1 
	GOTO        L__led7seg_decode58
L__led7seg_decode91:
;ballisticchronograph.mbas,273 :: 		case else result = Digit_NON
	CLRF        R1 
L__led7seg_decode58:
;ballisticchronograph.mbas,274 :: 		end select
	GOTO        L__led7seg_decode57
;ballisticchronograph.mbas,275 :: 		else
L__led7seg_decode56:
;ballisticchronograph.mbas,277 :: 		case " "  result = Digit_NON
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       32
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode95
	CLRF        R1 
	GOTO        L__led7seg_decode92
L__led7seg_decode95:
;ballisticchronograph.mbas,278 :: 		case "0"  result = Digit_0
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       48
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode98
	MOVLW       252
	MOVWF       R1 
	GOTO        L__led7seg_decode92
L__led7seg_decode98:
;ballisticchronograph.mbas,279 :: 		case "1"  result = Digit_1
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       49
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode101
	MOVLW       96
	MOVWF       R1 
	GOTO        L__led7seg_decode92
L__led7seg_decode101:
;ballisticchronograph.mbas,280 :: 		case "2"  result = Digit_2
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       50
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode104
	MOVLW       218
	MOVWF       R1 
	GOTO        L__led7seg_decode92
L__led7seg_decode104:
;ballisticchronograph.mbas,281 :: 		case "3"  result = Digit_3
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       51
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode107
	MOVLW       242
	MOVWF       R1 
	GOTO        L__led7seg_decode92
L__led7seg_decode107:
;ballisticchronograph.mbas,282 :: 		case "4"  result = Digit_4
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       52
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode110
	MOVLW       102
	MOVWF       R1 
	GOTO        L__led7seg_decode92
L__led7seg_decode110:
;ballisticchronograph.mbas,283 :: 		case "5"  result = Digit_5
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       53
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode113
	MOVLW       182
	MOVWF       R1 
	GOTO        L__led7seg_decode92
L__led7seg_decode113:
;ballisticchronograph.mbas,284 :: 		case "6"  result = Digit_6
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       54
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode116
	MOVLW       190
	MOVWF       R1 
	GOTO        L__led7seg_decode92
L__led7seg_decode116:
;ballisticchronograph.mbas,285 :: 		case "7"  result = Digit_7
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       55
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode119
	MOVLW       224
	MOVWF       R1 
	GOTO        L__led7seg_decode92
L__led7seg_decode119:
;ballisticchronograph.mbas,286 :: 		case "8"  result = Digit_8
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       56
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode122
	MOVLW       254
	MOVWF       R1 
	GOTO        L__led7seg_decode92
L__led7seg_decode122:
;ballisticchronograph.mbas,287 :: 		case "9"  result = Digit_9
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       57
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode125
	MOVLW       246
	MOVWF       R1 
	GOTO        L__led7seg_decode92
L__led7seg_decode125:
;ballisticchronograph.mbas,288 :: 		case else result = Digit_NON
	CLRF        R1 
L__led7seg_decode92:
;ballisticchronograph.mbas,290 :: 		end if
L__led7seg_decode57:
;ballisticchronograph.mbas,291 :: 		end sub
	MOVF        R1, 0 
	MOVWF       R0 
L_end_led7seg_decode:
	RETURN      0
; end of _led7seg_decode

_sw_test:

;ballisticchronograph.mbas,296 :: 		sub function sw_test( dim sw_no as byte ) as byte
;ballisticchronograph.mbas,297 :: 		if sw_enable = false then
	MOVF        _sw_enable+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__sw_test128
;ballisticchronograph.mbas,298 :: 		result = SW_OFF
	MOVLW       1
	MOVWF       R1 
	GOTO        L__sw_test129
;ballisticchronograph.mbas,299 :: 		else
L__sw_test128:
;ballisticchronograph.mbas,301 :: 		case 1
	MOVF        FARG_sw_test_sw_no+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__sw_test133
;ballisticchronograph.mbas,302 :: 		result = SW1_bit
	MOVLW       0
	BTFSC       PORTA+0, 3 
	MOVLW       1
	MOVWF       R1 
	GOTO        L__sw_test130
L__sw_test133:
;ballisticchronograph.mbas,303 :: 		case 2
	MOVF        FARG_sw_test_sw_no+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__sw_test136
;ballisticchronograph.mbas,304 :: 		result = SW2_bit
	MOVLW       0
	BTFSC       PORTB+0, 7 
	MOVLW       1
	MOVWF       R1 
	GOTO        L__sw_test130
L__sw_test136:
L__sw_test130:
;ballisticchronograph.mbas,306 :: 		end if
L__sw_test129:
;ballisticchronograph.mbas,308 :: 		if result = SW_ON then
	MOVF        R1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__sw_test138
;ballisticchronograph.mbas,309 :: 		sw_enable = FALSE
	CLRF        _sw_enable+0 
L__sw_test138:
;ballisticchronograph.mbas,311 :: 		end sub
	MOVF        R1, 0 
	MOVWF       R0 
L_end_sw_test:
	RETURN      0
; end of _sw_test

_sw_test_long:

;ballisticchronograph.mbas,318 :: 		sub function sw_test_long( dim sw_no as byte, dim time as word ) as boolean
;ballisticchronograph.mbas,319 :: 		result = false
	CLRF        R1 
;ballisticchronograph.mbas,321 :: 		case 1
	MOVF        FARG_sw_test_long_sw_no+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__sw_test_long144
;ballisticchronograph.mbas,322 :: 		if time <= sw1_long_counter then
	MOVF        FARG_sw_test_long_time+1, 0 
	SUBWF       _sw1_long_counter+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sw_test_long308
	MOVF        FARG_sw_test_long_time+0, 0 
	SUBWF       _sw1_long_counter+0, 0 
L__sw_test_long308:
	BTFSS       STATUS+0, 0 
	GOTO        L__sw_test_long146
;ballisticchronograph.mbas,323 :: 		result = true
	MOVLW       255
	MOVWF       R1 
L__sw_test_long146:
;ballisticchronograph.mbas,324 :: 		end if
	GOTO        L__sw_test_long141
L__sw_test_long144:
;ballisticchronograph.mbas,325 :: 		case 2
	MOVF        FARG_sw_test_long_sw_no+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__sw_test_long150
;ballisticchronograph.mbas,326 :: 		if time <= sw2_long_counter then
	MOVF        FARG_sw_test_long_time+1, 0 
	SUBWF       _sw2_long_counter+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sw_test_long309
	MOVF        FARG_sw_test_long_time+0, 0 
	SUBWF       _sw2_long_counter+0, 0 
L__sw_test_long309:
	BTFSS       STATUS+0, 0 
	GOTO        L__sw_test_long152
;ballisticchronograph.mbas,327 :: 		result = true
	MOVLW       255
	MOVWF       R1 
L__sw_test_long152:
;ballisticchronograph.mbas,328 :: 		end if
	GOTO        L__sw_test_long141
L__sw_test_long150:
L__sw_test_long141:
;ballisticchronograph.mbas,330 :: 		end sub
	MOVF        R1, 0 
	MOVWF       R0 
L_end_sw_test_long:
	RETURN      0
; end of _sw_test_long

_display_strobe_on:

;ballisticchronograph.mbas,336 :: 		sub procedure display_strobe_on()
;ballisticchronograph.mbas,337 :: 		TMR0IE_bit = INTERRUPT_ENABLE
	BSF         TMR0IE_bit+0, BitPos(TMR0IE_bit+0) 
;ballisticchronograph.mbas,338 :: 		TMR0ON_bit = TIMER_ON
	BSF         TMR0ON_bit+0, BitPos(TMR0ON_bit+0) 
;ballisticchronograph.mbas,339 :: 		end sub
L_end_display_strobe_on:
	RETURN      0
; end of _display_strobe_on

_display_strobe_off:

;ballisticchronograph.mbas,341 :: 		sub procedure display_strobe_off()
;ballisticchronograph.mbas,342 :: 		TMR0IE_bit = INTERRUPT_DISABLE
	BCF         TMR0IE_bit+0, BitPos(TMR0IE_bit+0) 
;ballisticchronograph.mbas,343 :: 		TMR0ON_bit = TIMER_OFF
	BCF         TMR0ON_bit+0, BitPos(TMR0ON_bit+0) 
;ballisticchronograph.mbas,344 :: 		end sub
L_end_display_strobe_off:
	RETURN      0
; end of _display_strobe_off

_set_message:

;ballisticchronograph.mbas,349 :: 		sub procedure set_message( dim error_code as byte )
;ballisticchronograph.mbas,351 :: 		case ERROR_SCREEN_1ST
	MOVF        FARG_set_message_error_code+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__set_message160
;ballisticchronograph.mbas,352 :: 		if upside_down then
	MOVF        _upside_down+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__set_message162
;ballisticchronograph.mbas,353 :: 		led_val1 = Digit_usd_E
	MOVLW       242
	MOVWF       _led_val1+0 
;ballisticchronograph.mbas,354 :: 		led_val2 = Digit_usd_r
	MOVLW       66
	MOVWF       _led_val2+0 
;ballisticchronograph.mbas,355 :: 		led_val3 = Digit_usd_r
	MOVLW       66
	MOVWF       _led_val3+0 
;ballisticchronograph.mbas,356 :: 		led_val4 = Digit_usd_1
	MOVLW       12
	MOVWF       _led_val4+0 
	GOTO        L__set_message163
;ballisticchronograph.mbas,357 :: 		else
L__set_message162:
;ballisticchronograph.mbas,358 :: 		led_val4 = Digit_E
	MOVLW       158
	MOVWF       _led_val4+0 
;ballisticchronograph.mbas,359 :: 		led_val3 = Digit_r
	MOVLW       10
	MOVWF       _led_val3+0 
;ballisticchronograph.mbas,360 :: 		led_val2 = Digit_r
	MOVLW       10
	MOVWF       _led_val2+0 
;ballisticchronograph.mbas,361 :: 		led_val1 = Digit_1
	MOVLW       96
	MOVWF       _led_val1+0 
;ballisticchronograph.mbas,362 :: 		end if
L__set_message163:
	GOTO        L__set_message157
L__set_message160:
;ballisticchronograph.mbas,363 :: 		case ERROR_FAST
	MOVF        FARG_set_message_error_code+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__set_message166
;ballisticchronograph.mbas,364 :: 		if upside_down then
	MOVF        _upside_down+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__set_message168
;ballisticchronograph.mbas,365 :: 		led_val1 = Digit_usd_F
	MOVLW       114
	MOVWF       _led_val1+0 
;ballisticchronograph.mbas,366 :: 		led_val2 = Digit_usd_A
	MOVLW       126
	MOVWF       _led_val2+0 
;ballisticchronograph.mbas,367 :: 		led_val3 = Digit_usd_S
	MOVLW       182
	MOVWF       _led_val3+0 
;ballisticchronograph.mbas,368 :: 		led_val4 = Digit_usd_t
	MOVLW       226
	MOVWF       _led_val4+0 
	GOTO        L__set_message169
;ballisticchronograph.mbas,369 :: 		else
L__set_message168:
;ballisticchronograph.mbas,370 :: 		led_val4 = Digit_F
	MOVLW       142
	MOVWF       _led_val4+0 
;ballisticchronograph.mbas,371 :: 		led_val3 = Digit_A
	MOVLW       238
	MOVWF       _led_val3+0 
;ballisticchronograph.mbas,372 :: 		led_val2 = Digit_S
	MOVLW       182
	MOVWF       _led_val2+0 
;ballisticchronograph.mbas,373 :: 		led_val1 = Digit_t
	MOVLW       30
	MOVWF       _led_val1+0 
;ballisticchronograph.mbas,374 :: 		end if
L__set_message169:
	GOTO        L__set_message157
L__set_message166:
;ballisticchronograph.mbas,375 :: 		case MSG_UP
	MOVF        FARG_set_message_error_code+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L__set_message172
;ballisticchronograph.mbas,376 :: 		led_val4 = Digit_usd_US
	MOVLW       128
	MOVWF       _led_val4+0 
;ballisticchronograph.mbas,377 :: 		led_val3 = Digit_U
	MOVLW       124
	MOVWF       _led_val3+0 
;ballisticchronograph.mbas,378 :: 		led_val2 = Digit_P
	MOVLW       206
	MOVWF       _led_val2+0 
;ballisticchronograph.mbas,379 :: 		led_val1 = Digit_usd_US
	MOVLW       128
	MOVWF       _led_val1+0 
	GOTO        L__set_message157
L__set_message172:
;ballisticchronograph.mbas,380 :: 		case MSG_DOWN
	MOVF        FARG_set_message_error_code+0, 0 
	XORLW       5
	BTFSS       STATUS+0, 2 
	GOTO        L__set_message175
;ballisticchronograph.mbas,381 :: 		led_val4 = Digit_US
	MOVLW       16
	MOVWF       _led_val4+0 
;ballisticchronograph.mbas,382 :: 		led_val3 = Digit_U
	MOVLW       124
	MOVWF       _led_val3+0 
;ballisticchronograph.mbas,383 :: 		led_val2 = Digit_P
	MOVLW       206
	MOVWF       _led_val2+0 
;ballisticchronograph.mbas,384 :: 		led_val1 = Digit_US
	MOVLW       16
	MOVWF       _led_val1+0 
	GOTO        L__set_message157
L__set_message175:
;ballisticchronograph.mbas,385 :: 		case MSG_SAVE
	MOVF        FARG_set_message_error_code+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__set_message178
;ballisticchronograph.mbas,386 :: 		led_val4 = Digit_S
	MOVLW       182
	MOVWF       _led_val4+0 
;ballisticchronograph.mbas,387 :: 		led_val3 = Digit_A
	MOVLW       238
	MOVWF       _led_val3+0 
;ballisticchronograph.mbas,388 :: 		led_val2 = Digit_U
	MOVLW       124
	MOVWF       _led_val2+0 
;ballisticchronograph.mbas,389 :: 		led_val1 = Digit_E
	MOVLW       158
	MOVWF       _led_val1+0 
	GOTO        L__set_message157
L__set_message178:
L__set_message157:
;ballisticchronograph.mbas,391 :: 		end sub
L_end_set_message:
	RETURN      0
; end of _set_message

_display_message:

;ballisticchronograph.mbas,396 :: 		sub procedure display_message( dim time_msec as word )
;ballisticchronograph.mbas,397 :: 		LED_DEV1_bit = LED_OFF
	BCF         LATB+0, 6 
;ballisticchronograph.mbas,398 :: 		LED_DEV2_bit = LED_OFF
	BCF         LATB+0, 5 
;ballisticchronograph.mbas,399 :: 		LED_DEV3_bit = LED_OFF
	BCF         LATB+0, 4 
;ballisticchronograph.mbas,400 :: 		LED_DEV4_bit = LED_OFF
	BCF         LATA+0, 1 
;ballisticchronograph.mbas,401 :: 		display_strobe_on()
	CALL        _display_strobe_on+0, 0
;ballisticchronograph.mbas,402 :: 		Vdelay_ms(time_msec)
	MOVF        FARG_display_message_time_msec+0, 0 
	MOVWF       FARG_VDelay_ms_Time_ms+0 
	MOVF        FARG_display_message_time_msec+1, 0 
	MOVWF       FARG_VDelay_ms_Time_ms+1 
	CALL        _VDelay_ms+0, 0
;ballisticchronograph.mbas,403 :: 		display_strobe_off()
	CALL        _display_strobe_off+0, 0
;ballisticchronograph.mbas,404 :: 		end sub
L_end_display_message:
	RETURN      0
; end of _display_message

_display_message_static:

;ballisticchronograph.mbas,409 :: 		sub procedure display_message_static( dim msg_id as byte )
;ballisticchronograph.mbas,411 :: 		case MSG_READY   ' -  -
	MOVF        FARG_display_message_static_msg_id+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__display_message_static184
;ballisticchronograph.mbas,412 :: 		LED_SEG_PORT = 0x00
	CLRF        LATC+0 
;ballisticchronograph.mbas,413 :: 		LED_DEV1_bit = LED_ON
	BSF         LATB+0, 6 
;ballisticchronograph.mbas,414 :: 		LED_DEV2_bit = LED_OFF
	BCF         LATB+0, 5 
;ballisticchronograph.mbas,415 :: 		LED_DEV3_bit = LED_OFF
	BCF         LATB+0, 4 
;ballisticchronograph.mbas,416 :: 		LED_DEV4_bit = LED_ON
	BSF         LATA+0, 1 
;ballisticchronograph.mbas,417 :: 		LED_SEG_G    = LED_ON
	BSF         LATC+0, 1 
	GOTO        L__display_message_static181
L__display_message_static184:
;ballisticchronograph.mbas,418 :: 		case MSG_TEST   ' -  -
	MOVF        FARG_display_message_static_msg_id+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__display_message_static187
;ballisticchronograph.mbas,419 :: 		LED_SEG_PORT = 0x00
	CLRF        LATC+0 
;ballisticchronograph.mbas,420 :: 		LED_DEV1_bit = LED_ON
	BSF         LATB+0, 6 
;ballisticchronograph.mbas,421 :: 		LED_DEV2_bit = LED_OFF
	BCF         LATB+0, 5 
;ballisticchronograph.mbas,422 :: 		LED_DEV3_bit = LED_OFF
	BCF         LATB+0, 4 
;ballisticchronograph.mbas,423 :: 		LED_DEV4_bit = LED_ON
	BSF         LATA+0, 1 
;ballisticchronograph.mbas,424 :: 		LED_SEG_A    = LED_ON
	BSF         LATC+0, 7 
	GOTO        L__display_message_static181
L__display_message_static187:
L__display_message_static181:
;ballisticchronograph.mbas,426 :: 		end sub
L_end_display_message_static:
	RETURN      0
; end of _display_message_static

_reset_screen:

;ballisticchronograph.mbas,431 :: 		sub procedure reset_screen()
;ballisticchronograph.mbas,432 :: 		display_message_static( MSG_READY )
	CLRF        FARG_display_message_static_msg_id+0 
	CALL        _display_message_static+0, 0
;ballisticchronograph.mbas,433 :: 		screen1st_detect = False
	CLRF        _screen1st_detect+0 
;ballisticchronograph.mbas,434 :: 		screen2nd_detect = False
	CLRF        _screen2nd_detect+0 
;ballisticchronograph.mbas,435 :: 		screen_timeout   = False
	CLRF        _screen_timeout+0 
;ballisticchronograph.mbas,436 :: 		delay_ms(100)
	MOVLW       9
	MOVWF       R11, 0
	MOVLW       30
	MOVWF       R12, 0
	MOVLW       228
	MOVWF       R13, 0
L__reset_screen189:
	DECFSZ      R13, 1, 1
	BRA         L__reset_screen189
	DECFSZ      R12, 1, 1
	BRA         L__reset_screen189
	DECFSZ      R11, 1, 1
	BRA         L__reset_screen189
	NOP
;ballisticchronograph.mbas,437 :: 		INT0IF_bit = FLAG_CLEAR
	BCF         INT0IF_bit+0, BitPos(INT0IF_bit+0) 
;ballisticchronograph.mbas,438 :: 		INT0IE_bit  = INTERRUPT_ENABLE
	BSF         INT0IE_bit+0, BitPos(INT0IE_bit+0) 
;ballisticchronograph.mbas,439 :: 		INT2IF_bit = FLAG_CLEAR
	BCF         INT2IF_bit+0, BitPos(INT2IF_bit+0) 
;ballisticchronograph.mbas,440 :: 		INT2IE_bit = INTERRUPT_DISABLE
	BCF         INT2IE_bit+0, BitPos(INT2IE_bit+0) 
;ballisticchronograph.mbas,441 :: 		TMR1ON_bit = TIMER_OFF
	BCF         TMR1ON_bit+0, BitPos(TMR1ON_bit+0) 
;ballisticchronograph.mbas,442 :: 		TMR1IF_bit = FLAG_CLEAR
	BCF         TMR1IF_bit+0, BitPos(TMR1IF_bit+0) 
;ballisticchronograph.mbas,443 :: 		TMR1IE_bit = INTERRUPT_DISABLE
	BCF         TMR1IE_bit+0, BitPos(TMR1IE_bit+0) 
;ballisticchronograph.mbas,444 :: 		end sub
L_end_reset_screen:
	RETURN      0
; end of _reset_screen

_calc_velocity:

;ballisticchronograph.mbas,451 :: 		dim divisor  as double
;ballisticchronograph.mbas,453 :: 		dividend = CONST_SEC * distance
	MOVF        FARG_calc_velocity_distance+0, 0 
	MOVWF       R0 
	MOVF        FARG_calc_velocity_distance+1, 0 
	MOVWF       R1 
	CALL        _Word2Double+0, 0
	MOVLW       0
	MOVWF       R4 
	MOVLW       36
	MOVWF       R5 
	MOVLW       116
	MOVWF       R6 
	MOVLW       150
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       FLOC__calc_velocity+4 
	MOVF        R1, 0 
	MOVWF       FLOC__calc_velocity+5 
	MOVF        R2, 0 
	MOVWF       FLOC__calc_velocity+6 
	MOVF        R3, 0 
	MOVWF       FLOC__calc_velocity+7 
	MOVF        FARG_calc_velocity_overflow+0, 0 
	MOVWF       R0 
	CALL        _Byte2Double+0, 0
;ballisticchronograph.mbas,454 :: 		divisor  = (tmr_value + (overflow * 0x10000)) * 100
	MOVLW       0
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVLW       0
	MOVWF       R6 
	MOVLW       143
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       FLOC__calc_velocity+0 
	MOVF        R1, 0 
	MOVWF       FLOC__calc_velocity+1 
	MOVF        R2, 0 
	MOVWF       FLOC__calc_velocity+2 
	MOVF        R3, 0 
	MOVWF       FLOC__calc_velocity+3 
	MOVF        FARG_calc_velocity_tmr_value+0, 0 
	MOVWF       R0 
	MOVF        FARG_calc_velocity_tmr_value+1, 0 
	MOVWF       R1 
	CALL        _Word2Double+0, 0
	MOVF        FLOC__calc_velocity+0, 0 
	MOVWF       R4 
	MOVF        FLOC__calc_velocity+1, 0 
	MOVWF       R5 
	MOVF        FLOC__calc_velocity+2, 0 
	MOVWF       R6 
	MOVF        FLOC__calc_velocity+3, 0 
	MOVWF       R7 
	CALL        _Add_32x32_FP+0, 0
	MOVLW       0
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVLW       72
	MOVWF       R6 
	MOVLW       133
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
;ballisticchronograph.mbas,455 :: 		result = dividend / divisor
	MOVF        R0, 0 
	MOVWF       R4 
	MOVF        R1, 0 
	MOVWF       R5 
	MOVF        R2, 0 
	MOVWF       R6 
	MOVF        R3, 0 
	MOVWF       R7 
	MOVF        FLOC__calc_velocity+4, 0 
	MOVWF       R0 
	MOVF        FLOC__calc_velocity+5, 0 
	MOVWF       R1 
	MOVF        FLOC__calc_velocity+6, 0 
	MOVWF       R2 
	MOVF        FLOC__calc_velocity+7, 0 
	MOVWF       R3 
	CALL        _Div_32x32_FP+0, 0
	CALL        _Double2Longword+0, 0
	MOVF        R0, 0 
	MOVWF       calc_velocity_local_result+0 
	MOVF        R1, 0 
	MOVWF       calc_velocity_local_result+1 
	MOVF        R2, 0 
	MOVWF       calc_velocity_local_result+2 
	MOVF        R3, 0 
	MOVWF       calc_velocity_local_result+3 
;ballisticchronograph.mbas,456 :: 		end sub
	MOVF        calc_velocity_local_result+0, 0 
	MOVWF       R0 
	MOVF        calc_velocity_local_result+1, 0 
	MOVWF       R1 
	MOVF        calc_velocity_local_result+2, 0 
	MOVWF       R2 
	MOVF        calc_velocity_local_result+3, 0 
	MOVWF       R3 
L_end_calc_velocity:
	RETURN      0
; end of _calc_velocity

_input_number:

;ballisticchronograph.mbas,470 :: 		dim long_temp as word
;ballisticchronograph.mbas,472 :: 		led_val1 = Digit_NON
	CLRF        _led_val1+0 
;ballisticchronograph.mbas,473 :: 		led_val2 = Digit_NON
	CLRF        _led_val2+0 
;ballisticchronograph.mbas,474 :: 		led_val3 = Digit_NON
	CLRF        _led_val3+0 
;ballisticchronograph.mbas,475 :: 		led_val4 = Digit_NON
	CLRF        _led_val4+0 
;ballisticchronograph.mbas,477 :: 		display_strobe_on()
	CALL        _display_strobe_on+0, 0
;ballisticchronograph.mbas,479 :: 		for i = 0 to digit_number - 1
	CLRF        input_number_i+0 
L__input_number192:
	DECF        FARG_input_number_digit_number+0, 0 
	MOVWF       FLOC__input_number+2 
	MOVF        input_number_i+0, 0 
	SUBWF       FLOC__input_number+2, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__input_number196
;ballisticchronograph.mbas,480 :: 		value[i] = initial mod 10
	MOVLW       input_number_value+0
	MOVWF       R0 
	MOVLW       hi_addr(input_number_value+0)
	MOVWF       R1 
	MOVF        input_number_i+0, 0 
	ADDWF       R0, 0 
	MOVWF       FLOC__input_number+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FLOC__input_number+1 
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVF        FARG_input_number_initial+0, 0 
	MOVWF       R0 
	MOVF        FARG_input_number_initial+1, 0 
	MOVWF       R1 
	CALL        _Div_16x16_U+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
	MOVFF       FLOC__input_number+0, FSR1
	MOVFF       FLOC__input_number+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;ballisticchronograph.mbas,481 :: 		initial  = initial  /  10
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVF        FARG_input_number_initial+0, 0 
	MOVWF       R0 
	MOVF        FARG_input_number_initial+1, 0 
	MOVWF       R1 
	CALL        _Div_16x16_U+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_input_number_initial+0 
	MOVF        R1, 0 
	MOVWF       FARG_input_number_initial+1 
;ballisticchronograph.mbas,482 :: 		next i
	MOVF        input_number_i+0, 0 
	XORWF       FLOC__input_number+2, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__input_number196
	INCF        input_number_i+0, 1 
	GOTO        L__input_number192
L__input_number196:
;ballisticchronograph.mbas,484 :: 		digit_index = 0
	CLRF        input_number_digit_index+0 
;ballisticchronograph.mbas,485 :: 		while sw_test_long(2,2000) = false
L__input_number198:
	MOVLW       2
	MOVWF       FARG_sw_test_long_sw_no+0 
	MOVLW       208
	MOVWF       FARG_sw_test_long_time+0 
	MOVLW       7
	MOVWF       FARG_sw_test_long_time+1 
	CALL        _sw_test_long+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__input_number199
;ballisticchronograph.mbas,486 :: 		if digit_number - 1 >= 0 then led_val1_tmp = led7seg_decode( value[0] + "0") end if
	DECF        FARG_input_number_digit_number+0, 0 
	MOVWF       R1 
	MOVLW       0
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__input_number203
	MOVLW       48
	ADDWF       input_number_value+0, 0 
	MOVWF       FARG_led7seg_decode_ascii_char+0 
	CALL        _led7seg_decode+0, 0
	MOVF        R0, 0 
	MOVWF       input_number_led_val1_tmp+0 
L__input_number203:
;ballisticchronograph.mbas,487 :: 		if digit_number - 1 >= 1 then led_val2_tmp = led7seg_decode( value[1] + "0") end if
	DECF        FARG_input_number_digit_number+0, 0 
	MOVWF       R1 
	MOVLW       1
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__input_number206
	MOVLW       48
	ADDWF       input_number_value+1, 0 
	MOVWF       FARG_led7seg_decode_ascii_char+0 
	CALL        _led7seg_decode+0, 0
	MOVF        R0, 0 
	MOVWF       input_number_led_val2_tmp+0 
L__input_number206:
;ballisticchronograph.mbas,488 :: 		if digit_number - 1 >= 2 then led_val3_tmp = led7seg_decode( value[2] + "0") end if
	DECF        FARG_input_number_digit_number+0, 0 
	MOVWF       R1 
	MOVLW       2
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__input_number209
	MOVLW       48
	ADDWF       input_number_value+2, 0 
	MOVWF       FARG_led7seg_decode_ascii_char+0 
	CALL        _led7seg_decode+0, 0
	MOVF        R0, 0 
	MOVWF       input_number_led_val3_tmp+0 
L__input_number209:
;ballisticchronograph.mbas,489 :: 		if digit_number - 1 >= 3 then led_val4_tmp = led7seg_decode( value[3] + "0") end if
	DECF        FARG_input_number_digit_number+0, 0 
	MOVWF       R1 
	MOVLW       3
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__input_number212
	MOVLW       48
	ADDWF       input_number_value+3, 0 
	MOVWF       FARG_led7seg_decode_ascii_char+0 
	CALL        _led7seg_decode+0, 0
	MOVF        R0, 0 
	MOVWF       input_number_led_val4_tmp+0 
L__input_number212:
;ballisticchronograph.mbas,492 :: 		case 0 led_val1_tmp = led_val1_tmp or Digit_DP
	MOVF        input_number_digit_index+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__input_number217
	BSF         input_number_led_val1_tmp+0, 0 
	GOTO        L__input_number214
L__input_number217:
;ballisticchronograph.mbas,493 :: 		case 1 led_val2_tmp = led_val2_tmp or Digit_DP
	MOVF        input_number_digit_index+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__input_number220
	BSF         input_number_led_val2_tmp+0, 0 
	GOTO        L__input_number214
L__input_number220:
;ballisticchronograph.mbas,494 :: 		case 2 led_val3_tmp = led_val3_tmp or Digit_DP
	MOVF        input_number_digit_index+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__input_number223
	BSF         input_number_led_val3_tmp+0, 0 
	GOTO        L__input_number214
L__input_number223:
;ballisticchronograph.mbas,495 :: 		case 3 led_val4_tmp = led_val4_tmp or Digit_DP
	MOVF        input_number_digit_index+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__input_number226
	BSF         input_number_led_val4_tmp+0, 0 
	GOTO        L__input_number214
L__input_number226:
L__input_number214:
;ballisticchronograph.mbas,498 :: 		if digit_number - 1 >= 0 then led_val1 = led_val1_tmp end if
	DECF        FARG_input_number_digit_number+0, 0 
	MOVWF       R1 
	MOVLW       0
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__input_number228
	MOVF        input_number_led_val1_tmp+0, 0 
	MOVWF       _led_val1+0 
L__input_number228:
;ballisticchronograph.mbas,499 :: 		if digit_number - 1 >= 1 then led_val2 = led_val2_tmp end if
	DECF        FARG_input_number_digit_number+0, 0 
	MOVWF       R1 
	MOVLW       1
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__input_number231
	MOVF        input_number_led_val2_tmp+0, 0 
	MOVWF       _led_val2+0 
L__input_number231:
;ballisticchronograph.mbas,500 :: 		if digit_number - 1 >= 2 then led_val3 = led_val3_tmp end if
	DECF        FARG_input_number_digit_number+0, 0 
	MOVWF       R1 
	MOVLW       2
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__input_number234
	MOVF        input_number_led_val3_tmp+0, 0 
	MOVWF       _led_val3+0 
L__input_number234:
;ballisticchronograph.mbas,501 :: 		if digit_number - 1 >= 3 then led_val4 = led_val4_tmp end if
	DECF        FARG_input_number_digit_number+0, 0 
	MOVWF       R1 
	MOVLW       3
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__input_number237
	MOVF        input_number_led_val4_tmp+0, 0 
	MOVWF       _led_val4+0 
L__input_number237:
;ballisticchronograph.mbas,503 :: 		if sw_test(2) = SW_ON then
	MOVLW       2
	MOVWF       FARG_sw_test_sw_no+0 
	CALL        _sw_test+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__input_number240
;ballisticchronograph.mbas,504 :: 		digit_index = digit_index + 1
	INCF        input_number_digit_index+0, 1 
;ballisticchronograph.mbas,505 :: 		if digit_index = digit_number then
	MOVF        input_number_digit_index+0, 0 
	XORWF       FARG_input_number_digit_number+0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__input_number243
;ballisticchronograph.mbas,506 :: 		digit_index = 0
	CLRF        input_number_digit_index+0 
L__input_number243:
;ballisticchronograph.mbas,507 :: 		end if
L__input_number240:
;ballisticchronograph.mbas,510 :: 		if sw_test(1) = SW_ON then
	MOVLW       1
	MOVWF       FARG_sw_test_sw_no+0 
	CALL        _sw_test+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__input_number246
;ballisticchronograph.mbas,511 :: 		if value[digit_index] = 9 then
	MOVLW       input_number_value+0
	MOVWF       R0 
	MOVLW       hi_addr(input_number_value+0)
	MOVWF       R1 
	MOVF        input_number_digit_index+0, 0 
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	XORLW       9
	BTFSS       STATUS+0, 2 
	GOTO        L__input_number249
;ballisticchronograph.mbas,512 :: 		value[digit_index] = 0
	MOVLW       input_number_value+0
	MOVWF       R0 
	MOVLW       hi_addr(input_number_value+0)
	MOVWF       R1 
	MOVF        input_number_digit_index+0, 0 
	ADDWF       R0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1H 
	CLRF        POSTINC1+0 
	GOTO        L__input_number250
;ballisticchronograph.mbas,513 :: 		else
L__input_number249:
;ballisticchronograph.mbas,514 :: 		value[digit_index] = value[digit_index] + 1
	MOVLW       input_number_value+0
	MOVWF       R0 
	MOVLW       hi_addr(input_number_value+0)
	MOVWF       R1 
	MOVF        input_number_digit_index+0, 0 
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVFF       R2, FSR0
	MOVFF       R3, FSR0H
	MOVF        POSTINC0+0, 0 
	ADDLW       1
	MOVWF       R0 
	MOVFF       R2, FSR1
	MOVFF       R3, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;ballisticchronograph.mbas,515 :: 		end if
L__input_number250:
L__input_number246:
;ballisticchronograph.mbas,517 :: 		wend
	GOTO        L__input_number198
L__input_number199:
;ballisticchronograph.mbas,519 :: 		result = 0
	CLRF        input_number_local_result+0 
	CLRF        input_number_local_result+1 
;ballisticchronograph.mbas,520 :: 		for i = digit_number - 1 to 0 step -1
	DECF        FARG_input_number_digit_number+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       input_number_i+0 
	MOVLW       0
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__input_number255
L__input_number252:
;ballisticchronograph.mbas,521 :: 		result = result * 10
	MOVF        input_number_local_result+0, 0 
	MOVWF       R0 
	MOVF        input_number_local_result+1, 0 
	MOVWF       R1 
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVF        R0, 0 
	MOVWF       input_number_local_result+0 
	MOVF        R1, 0 
	MOVWF       input_number_local_result+1 
;ballisticchronograph.mbas,522 :: 		long_temp = value[i]
	MOVLW       input_number_value+0
	MOVWF       R0 
	MOVLW       hi_addr(input_number_value+0)
	MOVWF       R1 
	MOVF        input_number_i+0, 0 
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       input_number_long_temp+0 
	MOVLW       0
	MOVWF       input_number_long_temp+1 
	MOVLW       0
	MOVWF       input_number_long_temp+1 
;ballisticchronograph.mbas,523 :: 		result = result + long_temp
	MOVF        input_number_long_temp+0, 0 
	ADDWF       input_number_local_result+0, 1 
	MOVF        input_number_long_temp+1, 0 
	ADDWFC      input_number_local_result+1, 1 
;ballisticchronograph.mbas,524 :: 		next i
	MOVF        input_number_i+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L__input_number255
	MOVLW       255
	ADDWF       input_number_i+0, 1 
	GOTO        L__input_number252
L__input_number255:
;ballisticchronograph.mbas,526 :: 		display_strobe_off()
	CALL        _display_strobe_off+0, 0
;ballisticchronograph.mbas,527 :: 		end sub
	MOVF        input_number_local_result+0, 0 
	MOVWF       R0 
	MOVF        input_number_local_result+1, 0 
	MOVWF       R1 
L_end_input_number:
	RETURN      0
; end of _input_number

_input_upside_down:

;ballisticchronograph.mbas,533 :: 		sub function input_upside_down(dim upside_down as byte) as boolean
;ballisticchronograph.mbas,534 :: 		display_strobe_on()
	CALL        _display_strobe_on+0, 0
;ballisticchronograph.mbas,535 :: 		while sw_test(2) = SW_OFF
L__input_upside_down258:
	MOVLW       2
	MOVWF       FARG_sw_test_sw_no+0 
	CALL        _sw_test+0, 0
	MOVF        R0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__input_upside_down259
;ballisticchronograph.mbas,536 :: 		if upside_down then
	MOVF        FARG_input_upside_down_upside_down+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__input_upside_down263
;ballisticchronograph.mbas,537 :: 		set_message( MSG_DOWN )
	MOVLW       5
	MOVWF       FARG_set_message_error_code+0 
	CALL        _set_message+0, 0
	GOTO        L__input_upside_down264
;ballisticchronograph.mbas,538 :: 		else
L__input_upside_down263:
;ballisticchronograph.mbas,539 :: 		set_message( MSG_UP   )
	MOVLW       4
	MOVWF       FARG_set_message_error_code+0 
	CALL        _set_message+0, 0
;ballisticchronograph.mbas,540 :: 		end if
L__input_upside_down264:
;ballisticchronograph.mbas,541 :: 		if sw_test(1) = SW_ON then
	MOVLW       1
	MOVWF       FARG_sw_test_sw_no+0 
	CALL        _sw_test+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__input_upside_down266
;ballisticchronograph.mbas,542 :: 		if upside_down then
	MOVF        FARG_input_upside_down_upside_down+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__input_upside_down269
;ballisticchronograph.mbas,543 :: 		upside_down = false
	CLRF        FARG_input_upside_down_upside_down+0 
	GOTO        L__input_upside_down270
;ballisticchronograph.mbas,544 :: 		else
L__input_upside_down269:
;ballisticchronograph.mbas,545 :: 		upside_down = true
	MOVLW       255
	MOVWF       FARG_input_upside_down_upside_down+0 
;ballisticchronograph.mbas,546 :: 		end if
L__input_upside_down270:
L__input_upside_down266:
;ballisticchronograph.mbas,548 :: 		wend
	GOTO        L__input_upside_down258
L__input_upside_down259:
;ballisticchronograph.mbas,549 :: 		result = upside_down
	MOVF        FARG_input_upside_down_upside_down+0, 0 
	MOVWF       input_upside_down_local_result+0 
;ballisticchronograph.mbas,551 :: 		display_strobe_off()
	CALL        _display_strobe_off+0, 0
;ballisticchronograph.mbas,552 :: 		end sub
	MOVF        input_upside_down_local_result+0, 0 
	MOVWF       R0 
L_end_input_upside_down:
	RETURN      0
; end of _input_upside_down

_main:

;ballisticchronograph.mbas,565 :: 		dim i as byte
;ballisticchronograph.mbas,568 :: 		RABPU_bit = 1 ' PORTA and PORTB pull-ups are disabled
	BSF         RABPU_bit+0, BitPos(RABPU_bit+0) 
;ballisticchronograph.mbas,569 :: 		WPUA = 0   ' 0:pull-up disable
	CLRF        WPUA+0 
;ballisticchronograph.mbas,570 :: 		WPUB = 0   ' 0:pull-up disable
	CLRF        WPUB+0 
;ballisticchronograph.mbas,573 :: 		SCREEN_1ST_TRIS = PORT_INPUT
	BSF         TRISA+0, 0 
;ballisticchronograph.mbas,574 :: 		SCREEN_2ND_TRIS = PORT_INPUT
	BSF         TRISA+0, 2 
;ballisticchronograph.mbas,575 :: 		ANS2_bit    = 0 ' PORT digital input   2nd screen
	BCF         ANS2_bit+0, BitPos(ANS2_bit+0) 
;ballisticchronograph.mbas,576 :: 		ANS0_bit    = 0 ' PORT digital input   1st screen
	BCF         ANS0_bit+0, BitPos(ANS0_bit+0) 
;ballisticchronograph.mbas,577 :: 		INTEDG2_bit = 1 ' 1:Interrupt on rising edge
	BSF         INTEDG2_bit+0, BitPos(INTEDG2_bit+0) 
;ballisticchronograph.mbas,578 :: 		INT2IP_bit  = HIGH_PRIORITY
	BSF         INT2IP_bit+0, BitPos(INT2IP_bit+0) 
;ballisticchronograph.mbas,579 :: 		INT2IE_bit  = INTERRUPT_DISABLE ' INT2 external interrupt
	BCF         INT2IE_bit+0, BitPos(INT2IE_bit+0) 
;ballisticchronograph.mbas,580 :: 		INT2IF_bit  = FLAG_CLEAR
	BCF         INT2IF_bit+0, BitPos(INT2IF_bit+0) 
;ballisticchronograph.mbas,581 :: 		INTEDG0_bit = 1 ' 1:Interrupt on rising edge
	BSF         INTEDG0_bit+0, BitPos(INTEDG0_bit+0) 
;ballisticchronograph.mbas,582 :: 		INT0IE_bit  = INTERRUPT_DISABLE ' INT0 external interrupt
	BCF         INT0IE_bit+0, BitPos(INT0IE_bit+0) 
;ballisticchronograph.mbas,583 :: 		INT0IF_bit  = FLAG_CLEAR ' Clear flag
	BCF         INT0IF_bit+0, BitPos(INT0IF_bit+0) 
;ballisticchronograph.mbas,586 :: 		SW1_TRIS = PORT_INPUT
	BSF         TRISA+0, 3 
;ballisticchronograph.mbas,587 :: 		SW2_TRIS = PORT_INPUT
	BSF         TRISB+0, 7 
;ballisticchronograph.mbas,590 :: 		LED_DEV1_TRIS = PORT_OUTPUT    ' 7 SEGMENT LED 1
	BCF         TRISB+0, 6 
;ballisticchronograph.mbas,591 :: 		LED_DEV2_TRIS = PORT_OUTPUT    ' 7 SEGMENT LED 2
	BCF         TRISB+0, 5 
;ballisticchronograph.mbas,592 :: 		LED_DEV3_TRIS = PORT_OUTPUT    ' 7 SEGMENT LED 3
	BCF         TRISB+0, 4 
;ballisticchronograph.mbas,593 :: 		LED_DEV4_TRIS = PORT_OUTPUT    ' 7 SEGMENT LED 4
	BCF         TRISA+0, 1 
;ballisticchronograph.mbas,594 :: 		LED_SEG_TRIS  = PORT_OUTPUT    ' 7 SEGMENT LED SEGMENT
	CLRF        TRISC+0 
;ballisticchronograph.mbas,596 :: 		led_txt  = "           "
	MOVLW       32
	MOVWF       main_led_txt+0 
	MOVLW       32
	MOVWF       main_led_txt+1 
	MOVLW       32
	MOVWF       main_led_txt+2 
	MOVLW       32
	MOVWF       main_led_txt+3 
	MOVLW       32
	MOVWF       main_led_txt+4 
	MOVLW       32
	MOVWF       main_led_txt+5 
	MOVLW       32
	MOVWF       main_led_txt+6 
	MOVLW       32
	MOVWF       main_led_txt+7 
	MOVLW       32
	MOVWF       main_led_txt+8 
	MOVLW       32
	MOVWF       main_led_txt+9 
	MOVLW       32
	MOVWF       main_led_txt+10 
	CLRF        main_led_txt+11 
;ballisticchronograph.mbas,597 :: 		led_pos  = 1
	MOVLW       1
	MOVWF       _led_pos+0 
;ballisticchronograph.mbas,598 :: 		sw_enable = true
	MOVLW       255
	MOVWF       _sw_enable+0 
;ballisticchronograph.mbas,601 :: 		T0PS2_bit   = 1  ' PreScaler 1:64
	BSF         T0PS2_bit+0, BitPos(T0PS2_bit+0) 
;ballisticchronograph.mbas,602 :: 		T0PS1_bit   = 0  ' PreScaler 1:64
	BCF         T0PS1_bit+0, BitPos(T0PS1_bit+0) 
;ballisticchronograph.mbas,603 :: 		T0PS0_bit   = 1  ' PreScaler 1:64
	BSF         T0PS0_bit+0, BitPos(T0PS0_bit+0) 
;ballisticchronograph.mbas,604 :: 		PSA_bit     = 0  ' PreScaler assign TMR0
	BCF         PSA_bit+0, BitPos(PSA_bit+0) 
;ballisticchronograph.mbas,605 :: 		T08BIT_bit  = 1  ' 1: 8bit mode
	BSF         T08BIT_bit+0, BitPos(T08BIT_bit+0) 
;ballisticchronograph.mbas,606 :: 		TMR0IP_bit  = LOW_PRIORITY
	BCF         TMR0IP_bit+0, BitPos(TMR0IP_bit+0) 
;ballisticchronograph.mbas,607 :: 		TMR0IE_bit  = INTERRUPT_DISABLE
	BCF         TMR0IE_bit+0, BitPos(TMR0IE_bit+0) 
;ballisticchronograph.mbas,608 :: 		TMR0IF_bit  = FLAG_CLEAR
	BCF         TMR0IF_bit+0, BitPos(TMR0IF_bit+0) 
;ballisticchronograph.mbas,609 :: 		T0CS_bit    = 0  ' 0:internal clock
	BCF         T0CS_bit+0, BitPos(T0CS_bit+0) 
;ballisticchronograph.mbas,610 :: 		TMR0ON_bit  = TIMER_OFF  ' 1:Enables Timer0
	BCF         TMR0ON_bit+0, BitPos(TMR0ON_bit+0) 
;ballisticchronograph.mbas,611 :: 		TMR0L       = 6  ' overflow 1 msec
	MOVLW       6
	MOVWF       TMR0L+0 
;ballisticchronograph.mbas,614 :: 		RD16_bit    = 1  ' 1:16bit mode
	BSF         RD16_bit+0, BitPos(RD16_bit+0) 
;ballisticchronograph.mbas,615 :: 		TMR1IF_bit  = FLAG_CLEAR
	BCF         TMR1IF_bit+0, BitPos(TMR1IF_bit+0) 
;ballisticchronograph.mbas,616 :: 		TMR1IE_bit  = INTERRUPT_DISABLE
	BCF         TMR1IE_bit+0, BitPos(TMR1IE_bit+0) 
;ballisticchronograph.mbas,617 :: 		TMR1IP_bit  = LOW_PRIORITY
	BCF         TMR1IP_bit+0, BitPos(TMR1IP_bit+0) 
;ballisticchronograph.mbas,618 :: 		T1CKPS1_bit = 0  ' set prescaler 1:1
	BCF         T1CKPS1_bit+0, BitPos(T1CKPS1_bit+0) 
;ballisticchronograph.mbas,619 :: 		T1CKPS0_bit = 0  ' set prescaler 1:1
	BCF         T1CKPS0_bit+0, BitPos(T1CKPS0_bit+0) 
;ballisticchronograph.mbas,620 :: 		TMR1CS_bit  = 0  ' 0:Internal clock (FOSC/4)
	BCF         TMR1CS_bit+0, BitPos(TMR1CS_bit+0) 
;ballisticchronograph.mbas,621 :: 		TMR1ON_bit  = TIMER_OFF
	BCF         TMR1ON_bit+0, BitPos(TMR1ON_bit+0) 
;ballisticchronograph.mbas,623 :: 		IPEN_bit = ENABLE  ' Enable priority levels on interrupts
	BSF         IPEN_bit+0, BitPos(IPEN_bit+0) 
;ballisticchronograph.mbas,624 :: 		GIEH_bit = ENABLE  ' all high priority interrupts
	BSF         GIEH_bit+0, BitPos(GIEH_bit+0) 
;ballisticchronograph.mbas,625 :: 		GIEL_bit = ENABLE  ' all low  priority interrupts
	BSF         GIEL_bit+0, BitPos(GIEL_bit+0) 
;ballisticchronograph.mbas,627 :: 		led_val1 = Digit_8
	MOVLW       254
	MOVWF       _led_val1+0 
;ballisticchronograph.mbas,628 :: 		led_val2 = Digit_8
	MOVLW       254
	MOVWF       _led_val2+0 
;ballisticchronograph.mbas,629 :: 		led_val3 = Digit_8
	MOVLW       254
	MOVWF       _led_val3+0 
;ballisticchronograph.mbas,630 :: 		led_val4 = Digit_8
	MOVLW       254
	MOVWF       _led_val4+0 
;ballisticchronograph.mbas,631 :: 		display_message( 500 )
	MOVLW       244
	MOVWF       FARG_display_message_time_msec+0 
	MOVLW       1
	MOVWF       FARG_display_message_time_msec+1 
	CALL        _display_message+0, 0
;ballisticchronograph.mbas,633 :: 		sw1_long_counter = 0
	CLRF        _sw1_long_counter+0 
	CLRF        _sw1_long_counter+1 
;ballisticchronograph.mbas,634 :: 		sw2_long_counter = 0
	CLRF        _sw2_long_counter+0 
	CLRF        _sw2_long_counter+1 
;ballisticchronograph.mbas,636 :: 		screen_distance_mm = eeprom_read( EEPADDR_DISTANCE ) + eeprom_read( EEPADDR_DISTANCE + 1 ) * 0x100
	CLRF        FARG_EEPROM_Read_address+0 
	CLRF        FARG_EEPROM_Read_address+1 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       FLOC__main+0 
	MOVLW       1
	MOVWF       FARG_EEPROM_Read_address+0 
	MOVLW       0
	MOVWF       FARG_EEPROM_Read_address+1 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       R2 
	CLRF        R1 
	MOVF        FLOC__main+0, 0 
	ADDWF       R1, 0 
	MOVWF       main_screen_distance_mm+0 
	MOVLW       0
	ADDWFC      R2, 0 
	MOVWF       main_screen_distance_mm+1 
;ballisticchronograph.mbas,638 :: 		if sw_test(2) = SW_ON then
	MOVLW       2
	MOVWF       FARG_sw_test_sw_no+0 
	CALL        _sw_test+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main273
;ballisticchronograph.mbas,640 :: 		screen_distance_mm = input_number( 3, screen_distance_mm )
	MOVLW       3
	MOVWF       FARG_input_number_digit_number+0 
	MOVF        main_screen_distance_mm+0, 0 
	MOVWF       FARG_input_number_initial+0 
	MOVF        main_screen_distance_mm+1, 0 
	MOVWF       FARG_input_number_initial+1 
	CALL        _input_number+0, 0
	MOVF        R0, 0 
	MOVWF       main_screen_distance_mm+0 
	MOVF        R1, 0 
	MOVWF       main_screen_distance_mm+1 
;ballisticchronograph.mbas,641 :: 		if screen_distance_mm = 0 then
	MOVLW       0
	XORWF       R1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main320
	MOVLW       0
	XORWF       R0, 0 
L__main320:
	BTFSS       STATUS+0, 2 
	GOTO        L__main276
;ballisticchronograph.mbas,642 :: 		screen_distance_mm = DEFAULT_SCREEN_DISTANCE
	MOVLW       44
	MOVWF       main_screen_distance_mm+0 
	MOVLW       1
	MOVWF       main_screen_distance_mm+1 
L__main276:
;ballisticchronograph.mbas,644 :: 		set_message( MSG_SAVE )
	MOVLW       2
	MOVWF       FARG_set_message_error_code+0 
	CALL        _set_message+0, 0
;ballisticchronograph.mbas,645 :: 		eeprom_write( EEPADDR_DISTANCE,   screen_distance_mm mod 0x100 )
	CLRF        FARG_EEPROM_Write_address+0 
	MOVLW       255
	ANDWF       main_screen_distance_mm+0, 0 
	MOVWF       R0 
	MOVF        main_screen_distance_mm+1, 0 
	MOVWF       R1 
	MOVLW       0
	ANDWF       R1, 1 
	MOVF        R0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;ballisticchronograph.mbas,646 :: 		eeprom_write( EEPADDR_DISTANCE+1, screen_distance_mm  /  0x100 )
	MOVLW       1
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        main_screen_distance_mm+1, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVF        R0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;ballisticchronograph.mbas,647 :: 		display_message( 1000 )
	MOVLW       232
	MOVWF       FARG_display_message_time_msec+0 
	MOVLW       3
	MOVWF       FARG_display_message_time_msec+1 
	CALL        _display_message+0, 0
;ballisticchronograph.mbas,649 :: 		upside_down = input_upside_down(eeprom_read( EEPADDR_UPSIDE_DOWN ))
	MOVLW       2
	MOVWF       FARG_EEPROM_Read_address+0 
	MOVLW       0
	MOVWF       FARG_EEPROM_Read_address+1 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_input_upside_down_upside_down+0 
	CALL        _input_upside_down+0, 0
	MOVF        R0, 0 
	MOVWF       _upside_down+0 
;ballisticchronograph.mbas,650 :: 		set_message( MSG_SAVE )
	MOVLW       2
	MOVWF       FARG_set_message_error_code+0 
	CALL        _set_message+0, 0
;ballisticchronograph.mbas,651 :: 		eeprom_write( EEPADDR_UPSIDE_DOWN, upside_down )
	MOVLW       2
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _upside_down+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;ballisticchronograph.mbas,652 :: 		display_message( 1000 )
	MOVLW       232
	MOVWF       FARG_display_message_time_msec+0 
	MOVLW       3
	MOVWF       FARG_display_message_time_msec+1 
	CALL        _display_message+0, 0
L__main273:
;ballisticchronograph.mbas,655 :: 		upside_down = eeprom_read( EEPADDR_UPSIDE_DOWN )
	MOVLW       2
	MOVWF       FARG_EEPROM_Read_address+0 
	MOVLW       0
	MOVWF       FARG_EEPROM_Read_address+1 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _upside_down+0 
;ballisticchronograph.mbas,656 :: 		reset_screen()
	CALL        _reset_screen+0, 0
;ballisticchronograph.mbas,657 :: 		while true
L__main279:
;ballisticchronograph.mbas,659 :: 		if screen_timeout then
	MOVF        _screen_timeout+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main284
;ballisticchronograph.mbas,660 :: 		set_message( ERROR_SCREEN_1ST )
	MOVLW       1
	MOVWF       FARG_set_message_error_code+0 
	CALL        _set_message+0, 0
;ballisticchronograph.mbas,661 :: 		display_message( 500 )
	MOVLW       244
	MOVWF       FARG_display_message_time_msec+0 
	MOVLW       1
	MOVWF       FARG_display_message_time_msec+1 
	CALL        _display_message+0, 0
;ballisticchronograph.mbas,662 :: 		reset_screen()
	CALL        _reset_screen+0, 0
L__main284:
;ballisticchronograph.mbas,665 :: 		if screen2nd_detect = true then
	MOVF        _screen2nd_detect+0, 0 
	XORLW       255
	BTFSS       STATUS+0, 2 
	GOTO        L__main287
;ballisticchronograph.mbas,666 :: 		velocity = calc_velocity( tmr1H_save * 0x100 + tmr1L_save, tmr1_oveflow_count_save, screen_distance_mm )
	MOVF        _tmr1H_save+0, 0 
	MOVWF       FARG_calc_velocity_tmr_value+1 
	CLRF        FARG_calc_velocity_tmr_value+0 
	MOVF        _tmr1L_save+0, 0 
	ADDWF       FARG_calc_velocity_tmr_value+0, 1 
	MOVLW       0
	ADDWFC      FARG_calc_velocity_tmr_value+1, 1 
	MOVF        _tmr1_oveflow_count_save+0, 0 
	MOVWF       FARG_calc_velocity_overflow+0 
	MOVF        main_screen_distance_mm+0, 0 
	MOVWF       FARG_calc_velocity_distance+0 
	MOVF        main_screen_distance_mm+1, 0 
	MOVWF       FARG_calc_velocity_distance+1 
	CALL        _calc_velocity+0, 0
	MOVF        R0, 0 
	MOVWF       main_velocity+0 
	MOVF        R1, 0 
	MOVWF       main_velocity+1 
	MOVF        R2, 0 
	MOVWF       main_velocity+2 
	MOVF        R3, 0 
	MOVWF       main_velocity+3 
;ballisticchronograph.mbas,667 :: 		if 9999 < velocity then
	MOVF        R3, 0 
	SUBLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main321
	MOVF        R2, 0 
	SUBLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main321
	MOVF        R1, 0 
	SUBLW       39
	BTFSS       STATUS+0, 2 
	GOTO        L__main321
	MOVF        R0, 0 
	SUBLW       15
L__main321:
	BTFSC       STATUS+0, 0 
	GOTO        L__main290
;ballisticchronograph.mbas,668 :: 		set_message( ERROR_FAST )
	MOVLW       3
	MOVWF       FARG_set_message_error_code+0 
	CALL        _set_message+0, 0
	GOTO        L__main291
;ballisticchronograph.mbas,669 :: 		else
L__main290:
;ballisticchronograph.mbas,670 :: 		LongintToStr( velocity, led_txt )
	MOVF        main_velocity+0, 0 
	MOVWF       FARG_LongIntToStr_input+0 
	MOVF        main_velocity+1, 0 
	MOVWF       FARG_LongIntToStr_input+1 
	MOVF        main_velocity+2, 0 
	MOVWF       FARG_LongIntToStr_input+2 
	MOVF        main_velocity+3, 0 
	MOVWF       FARG_LongIntToStr_input+3 
	MOVLW       main_led_txt+0
	MOVWF       FARG_LongIntToStr_output+0 
	MOVLW       hi_addr(main_led_txt+0)
	MOVWF       FARG_LongIntToStr_output+1 
	CALL        _LongIntToStr+0, 0
;ballisticchronograph.mbas,671 :: 		if upside_down then
	MOVF        _upside_down+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main293
;ballisticchronograph.mbas,672 :: 		led_val4 = led7seg_decode( led_txt[10] ) or Digit_DP
	MOVF        main_led_txt+10, 0 
	MOVWF       FARG_led7seg_decode_ascii_char+0 
	CALL        _led7seg_decode+0, 0
	MOVLW       1
	IORWF       R0, 0 
	MOVWF       _led_val4+0 
;ballisticchronograph.mbas,673 :: 		led_val3 = led7seg_decode( led_txt[9]  )
	MOVF        main_led_txt+9, 0 
	MOVWF       FARG_led7seg_decode_ascii_char+0 
	CALL        _led7seg_decode+0, 0
	MOVF        R0, 0 
	MOVWF       _led_val3+0 
;ballisticchronograph.mbas,674 :: 		led_val2 = led7seg_decode( led_txt[8]  )
	MOVF        main_led_txt+8, 0 
	MOVWF       FARG_led7seg_decode_ascii_char+0 
	CALL        _led7seg_decode+0, 0
	MOVF        R0, 0 
	MOVWF       _led_val2+0 
;ballisticchronograph.mbas,675 :: 		led_val1 = led7seg_decode( led_txt[7]  )
	MOVF        main_led_txt+7, 0 
	MOVWF       FARG_led7seg_decode_ascii_char+0 
	CALL        _led7seg_decode+0, 0
	MOVF        R0, 0 
	MOVWF       _led_val1+0 
	GOTO        L__main294
;ballisticchronograph.mbas,676 :: 		else
L__main293:
;ballisticchronograph.mbas,677 :: 		led_val1 = led7seg_decode( led_txt[10] )
	MOVF        main_led_txt+10, 0 
	MOVWF       FARG_led7seg_decode_ascii_char+0 
	CALL        _led7seg_decode+0, 0
	MOVF        R0, 0 
	MOVWF       _led_val1+0 
;ballisticchronograph.mbas,678 :: 		led_val2 = led7seg_decode( led_txt[9]  ) or Digit_DP
	MOVF        main_led_txt+9, 0 
	MOVWF       FARG_led7seg_decode_ascii_char+0 
	CALL        _led7seg_decode+0, 0
	MOVLW       1
	IORWF       R0, 0 
	MOVWF       _led_val2+0 
;ballisticchronograph.mbas,679 :: 		led_val3 = led7seg_decode( led_txt[8]  )
	MOVF        main_led_txt+8, 0 
	MOVWF       FARG_led7seg_decode_ascii_char+0 
	CALL        _led7seg_decode+0, 0
	MOVF        R0, 0 
	MOVWF       _led_val3+0 
;ballisticchronograph.mbas,680 :: 		led_val4 = led7seg_decode( led_txt[7]  )
	MOVF        main_led_txt+7, 0 
	MOVWF       FARG_led7seg_decode_ascii_char+0 
	CALL        _led7seg_decode+0, 0
	MOVF        R0, 0 
	MOVWF       _led_val4+0 
;ballisticchronograph.mbas,681 :: 		end if
L__main294:
;ballisticchronograph.mbas,682 :: 		end if
L__main291:
;ballisticchronograph.mbas,683 :: 		display_message( 4000 )
	MOVLW       160
	MOVWF       FARG_display_message_time_msec+0 
	MOVLW       15
	MOVWF       FARG_display_message_time_msec+1 
	CALL        _display_message+0, 0
;ballisticchronograph.mbas,684 :: 		reset_screen()
	CALL        _reset_screen+0, 0
L__main287:
;ballisticchronograph.mbas,686 :: 		wend
	GOTO        L__main279
L_end_main:
	GOTO        $+0
; end of _main
